"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Copyright 2023 Google LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
"""

import builtins
import google.protobuf.descriptor
import google.protobuf.descriptor_pb2
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.internal.extension_dict
import google.protobuf.message
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing_extensions.final
class FieldInfo(google.protobuf.message.Message):
    """Rich semantic information of an API field beyond basic typing."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class _Format:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _FormatEnumTypeWrapper(
        google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[
            FieldInfo._Format.ValueType
        ],
        builtins.type,
    ):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        FORMAT_UNSPECIFIED: FieldInfo._Format.ValueType  # 0
        """Default, unspecified value."""
        UUID4: FieldInfo._Format.ValueType  # 1
        """Universally Unique Identifier, version 4, value as defined by
        https://datatracker.ietf.org/doc/html/rfc4122. The value may be
        normalized to entirely lowercase letters. For example, the value
        `F47AC10B-58CC-0372-8567-0E02B2C3D479` would be normalized to
        `f47ac10b-58cc-0372-8567-0e02b2c3d479`.
        """
        IPV4: FieldInfo._Format.ValueType  # 2
        """Internet Protocol v4 value as defined by [RFC
        791](https://datatracker.ietf.org/doc/html/rfc791). The value may be
        condensed, with leading zeros in each octet stripped. For example,
        `001.022.233.040` would be condensed to `1.22.233.40`.
        """
        IPV6: FieldInfo._Format.ValueType  # 3
        """Internet Protocol v6 value as defined by [RFC
        2460](https://datatracker.ietf.org/doc/html/rfc2460). The value may be
        normalized to entirely lowercase letters, and zero-padded partial and
        empty octets. For example, the value `2001:DB8::` would be normalized to
        `2001:0db8:0:0`.
        """
        IPV4_OR_IPV6: FieldInfo._Format.ValueType  # 4
        """An IP address in either v4 or v6 format as described by the individual
        values defined herein. See the comments on the IPV4 and IPV6 types for
        allowed normalizations of each.
        """

    class Format(_Format, metaclass=_FormatEnumTypeWrapper):
        """The standard format of a field value. The supported formats are all backed
        by either an RFC defined by the IETF or a Google-defined AIP.
        """

    FORMAT_UNSPECIFIED: FieldInfo.Format.ValueType  # 0
    """Default, unspecified value."""
    UUID4: FieldInfo.Format.ValueType  # 1
    """Universally Unique Identifier, version 4, value as defined by
    https://datatracker.ietf.org/doc/html/rfc4122. The value may be
    normalized to entirely lowercase letters. For example, the value
    `F47AC10B-58CC-0372-8567-0E02B2C3D479` would be normalized to
    `f47ac10b-58cc-0372-8567-0e02b2c3d479`.
    """
    IPV4: FieldInfo.Format.ValueType  # 2
    """Internet Protocol v4 value as defined by [RFC
    791](https://datatracker.ietf.org/doc/html/rfc791). The value may be
    condensed, with leading zeros in each octet stripped. For example,
    `001.022.233.040` would be condensed to `1.22.233.40`.
    """
    IPV6: FieldInfo.Format.ValueType  # 3
    """Internet Protocol v6 value as defined by [RFC
    2460](https://datatracker.ietf.org/doc/html/rfc2460). The value may be
    normalized to entirely lowercase letters, and zero-padded partial and
    empty octets. For example, the value `2001:DB8::` would be normalized to
    `2001:0db8:0:0`.
    """
    IPV4_OR_IPV6: FieldInfo.Format.ValueType  # 4
    """An IP address in either v4 or v6 format as described by the individual
    values defined herein. See the comments on the IPV4 and IPV6 types for
    allowed normalizations of each.
    """

    FORMAT_FIELD_NUMBER: builtins.int
    format: global___FieldInfo.Format.ValueType
    """The standard format of a field value. This does not explicitly configure
    any API consumer, just documents the API's format for the field it is
    applied to.
    """
    def __init__(
        self,
        *,
        format: global___FieldInfo.Format.ValueType = ...,
    ) -> None: ...
    def ClearField(
        self, field_name: typing_extensions.Literal["format", b"format"]
    ) -> None: ...

global___FieldInfo = FieldInfo

FIELD_INFO_FIELD_NUMBER: builtins.int
field_info: google.protobuf.internal.extension_dict._ExtensionFieldDescriptor[
    google.protobuf.descriptor_pb2.FieldOptions, global___FieldInfo
]
"""Rich semantic descriptor of an API field beyond the basic typing.

Examples:

  string request_id = 1 [(google.api.field_info).format = UUID4];
  string old_ip_address = 2 [(google.api.field_info).format = IPV4];
  string new_ip_address = 3 [(google.api.field_info).format = IPV6];
  string actual_ip_address = 4 [
    (google.api.field_info).format = IPV4_OR_IPV6
  ];
"""
