"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Copyright 2020 Google LLC.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
"""

import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import sys

if sys.version_info >= (3, 8):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing_extensions.final
class GapicMetadata(google.protobuf.message.Message):
    """Metadata about a GAPIC library for a specific combination of API, version, and
    computer language.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing_extensions.final
    class ServicesEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> global___GapicMetadata.ServiceForTransport: ...
        def __init__(
            self,
            *,
            key: builtins.str = ...,
            value: global___GapicMetadata.ServiceForTransport | None = ...,
        ) -> None: ...
        def HasField(
            self, field_name: typing_extensions.Literal["value", b"value"]
        ) -> builtins.bool: ...
        def ClearField(
            self,
            field_name: typing_extensions.Literal["key", b"key", "value", b"value"],
        ) -> None: ...

    @typing_extensions.final
    class ServiceForTransport(google.protobuf.message.Message):
        """A map from a transport name to ServiceAsClient, which allows
        listing information about the client objects that implement the
        parent RPC service for the specified transport.

        The key name is the transport, lower-cased with no separators
        (e.g. "grpc", "rest").
        """

        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        @typing_extensions.final
        class ClientsEntry(google.protobuf.message.Message):
            DESCRIPTOR: google.protobuf.descriptor.Descriptor

            KEY_FIELD_NUMBER: builtins.int
            VALUE_FIELD_NUMBER: builtins.int
            key: builtins.str
            @property
            def value(self) -> global___GapicMetadata.ServiceAsClient: ...
            def __init__(
                self,
                *,
                key: builtins.str = ...,
                value: global___GapicMetadata.ServiceAsClient | None = ...,
            ) -> None: ...
            def HasField(
                self, field_name: typing_extensions.Literal["value", b"value"]
            ) -> builtins.bool: ...
            def ClearField(
                self,
                field_name: typing_extensions.Literal["key", b"key", "value", b"value"],
            ) -> None: ...

        CLIENTS_FIELD_NUMBER: builtins.int
        @property
        def clients(
            self,
        ) -> google.protobuf.internal.containers.MessageMap[
            builtins.str, global___GapicMetadata.ServiceAsClient
        ]: ...
        def __init__(
            self,
            *,
            clients: (
                collections.abc.Mapping[
                    builtins.str, global___GapicMetadata.ServiceAsClient
                ]
                | None
            ) = ...,
        ) -> None: ...
        def ClearField(
            self, field_name: typing_extensions.Literal["clients", b"clients"]
        ) -> None: ...

    @typing_extensions.final
    class ServiceAsClient(google.protobuf.message.Message):
        """Information about a specific client implementing a proto-defined service."""

        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        @typing_extensions.final
        class RpcsEntry(google.protobuf.message.Message):
            DESCRIPTOR: google.protobuf.descriptor.Descriptor

            KEY_FIELD_NUMBER: builtins.int
            VALUE_FIELD_NUMBER: builtins.int
            key: builtins.str
            @property
            def value(self) -> global___GapicMetadata.MethodList: ...
            def __init__(
                self,
                *,
                key: builtins.str = ...,
                value: global___GapicMetadata.MethodList | None = ...,
            ) -> None: ...
            def HasField(
                self, field_name: typing_extensions.Literal["value", b"value"]
            ) -> builtins.bool: ...
            def ClearField(
                self,
                field_name: typing_extensions.Literal["key", b"key", "value", b"value"],
            ) -> None: ...

        LIBRARY_CLIENT_FIELD_NUMBER: builtins.int
        RPCS_FIELD_NUMBER: builtins.int
        library_client: builtins.str
        """The name of the library client formatted as it appears in the source code"""
        @property
        def rpcs(
            self,
        ) -> google.protobuf.internal.containers.MessageMap[
            builtins.str, global___GapicMetadata.MethodList
        ]:
            """A mapping from each proto-defined RPC name to the the list of
            methods in library_client that implement it. There can be more
            than one library_client method for each RPC. RPCs with no
            library_client methods need not be included.

            The key name is the name of the RPC as defined and formated in
            the proto file.
            """

        def __init__(
            self,
            *,
            library_client: builtins.str = ...,
            rpcs: (
                collections.abc.Mapping[builtins.str, global___GapicMetadata.MethodList]
                | None
            ) = ...,
        ) -> None: ...
        def ClearField(
            self,
            field_name: typing_extensions.Literal[
                "library_client", b"library_client", "rpcs", b"rpcs"
            ],
        ) -> None: ...

    @typing_extensions.final
    class MethodList(google.protobuf.message.Message):
        """List of GAPIC client methods implementing the proto-defined RPC
        for the transport and service specified in the containing
        structures.
        """

        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        METHODS_FIELD_NUMBER: builtins.int
        @property
        def methods(
            self,
        ) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[
            builtins.str
        ]:
            """List of methods for a specific proto-service client in the
            GAPIC. These names should be formatted as they appear in the
            source code.
            """

        def __init__(
            self,
            *,
            methods: collections.abc.Iterable[builtins.str] | None = ...,
        ) -> None: ...
        def ClearField(
            self, field_name: typing_extensions.Literal["methods", b"methods"]
        ) -> None: ...

    SCHEMA_FIELD_NUMBER: builtins.int
    COMMENT_FIELD_NUMBER: builtins.int
    LANGUAGE_FIELD_NUMBER: builtins.int
    PROTO_PACKAGE_FIELD_NUMBER: builtins.int
    LIBRARY_PACKAGE_FIELD_NUMBER: builtins.int
    SERVICES_FIELD_NUMBER: builtins.int
    schema: builtins.str
    """Schema version of this proto. Current value: 1.0"""
    comment: builtins.str
    """Any human-readable comments to be included in this file."""
    language: builtins.str
    """Computer language of this generated language. This must be
    spelled out as it spoken in English, with no capitalization or
    separators (e.g. "csharp", "nodejs").
    """
    proto_package: builtins.str
    """The proto package containing the API definition for which this
    GAPIC library was generated.
    """
    library_package: builtins.str
    """The language-specific library package for this GAPIC library."""
    @property
    def services(
        self,
    ) -> google.protobuf.internal.containers.MessageMap[
        builtins.str, global___GapicMetadata.ServiceForTransport
    ]:
        """A map from each proto-defined service to ServiceForTransports,
        which allows listing information about transport-specific
        implementations of the service.

        The key is the name of the service as it appears in the .proto
        file.
        """

    def __init__(
        self,
        *,
        schema: builtins.str = ...,
        comment: builtins.str = ...,
        language: builtins.str = ...,
        proto_package: builtins.str = ...,
        library_package: builtins.str = ...,
        services: (
            collections.abc.Mapping[
                builtins.str, global___GapicMetadata.ServiceForTransport
            ]
            | None
        ) = ...,
    ) -> None: ...
    def ClearField(
        self,
        field_name: typing_extensions.Literal[
            "comment",
            b"comment",
            "language",
            b"language",
            "library_package",
            b"library_package",
            "proto_package",
            b"proto_package",
            "schema",
            b"schema",
            "services",
            b"services",
        ],
    ) -> None: ...

global___GapicMetadata = GapicMetadata
