"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Copyright 2022 Google LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
"""

import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import sys

if sys.version_info >= (3, 8):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing_extensions.final
class HttpRequest(google.protobuf.message.Message):
    """Represents an HTTP request."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METHOD_FIELD_NUMBER: builtins.int
    URI_FIELD_NUMBER: builtins.int
    HEADERS_FIELD_NUMBER: builtins.int
    BODY_FIELD_NUMBER: builtins.int
    method: builtins.str
    """The HTTP request method."""
    uri: builtins.str
    """The HTTP request URI."""
    @property
    def headers(
        self,
    ) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[
        global___HttpHeader
    ]:
        """The HTTP request headers. The ordering of the headers is significant.
        Multiple headers with the same key may present for the request.
        """
    body: builtins.bytes
    """The HTTP request body. If the body is not expected, it should be empty."""
    def __init__(
        self,
        *,
        method: builtins.str = ...,
        uri: builtins.str = ...,
        headers: collections.abc.Iterable[global___HttpHeader] | None = ...,
        body: builtins.bytes = ...,
    ) -> None: ...
    def ClearField(
        self,
        field_name: typing_extensions.Literal[
            "body", b"body", "headers", b"headers", "method", b"method", "uri", b"uri"
        ],
    ) -> None: ...

global___HttpRequest = HttpRequest

@typing_extensions.final
class HttpResponse(google.protobuf.message.Message):
    """Represents an HTTP response."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    STATUS_FIELD_NUMBER: builtins.int
    REASON_FIELD_NUMBER: builtins.int
    HEADERS_FIELD_NUMBER: builtins.int
    BODY_FIELD_NUMBER: builtins.int
    status: builtins.int
    """The HTTP status code, such as 200 or 404."""
    reason: builtins.str
    """The HTTP reason phrase, such as "OK" or "Not Found"."""
    @property
    def headers(
        self,
    ) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[
        global___HttpHeader
    ]:
        """The HTTP response headers. The ordering of the headers is significant.
        Multiple headers with the same key may present for the response.
        """
    body: builtins.bytes
    """The HTTP response body. If the body is not expected, it should be empty."""
    def __init__(
        self,
        *,
        status: builtins.int = ...,
        reason: builtins.str = ...,
        headers: collections.abc.Iterable[global___HttpHeader] | None = ...,
        body: builtins.bytes = ...,
    ) -> None: ...
    def ClearField(
        self,
        field_name: typing_extensions.Literal[
            "body",
            b"body",
            "headers",
            b"headers",
            "reason",
            b"reason",
            "status",
            b"status",
        ],
    ) -> None: ...

global___HttpResponse = HttpResponse

@typing_extensions.final
class HttpHeader(google.protobuf.message.Message):
    """Represents an HTTP header."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    VALUE_FIELD_NUMBER: builtins.int
    key: builtins.str
    """The HTTP header key. It is case insensitive."""
    value: builtins.str
    """The HTTP header value."""
    def __init__(
        self,
        *,
        key: builtins.str = ...,
        value: builtins.str = ...,
    ) -> None: ...
    def ClearField(
        self, field_name: typing_extensions.Literal["key", b"key", "value", b"value"]
    ) -> None: ...

global___HttpHeader = HttpHeader
