"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Copyright 2021 Google LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
"""

import builtins
import google.protobuf.descriptor
import google.protobuf.internal.enum_type_wrapper
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _CalendarPeriod:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _CalendarPeriodEnumTypeWrapper(
    google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[
        _CalendarPeriod.ValueType
    ],
    builtins.type,
):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    CALENDAR_PERIOD_UNSPECIFIED: _CalendarPeriod.ValueType  # 0
    """Undefined period, raises an error."""
    DAY: _CalendarPeriod.ValueType  # 1
    """A day."""
    WEEK: _CalendarPeriod.ValueType  # 2
    """A week. Weeks begin on Monday, following
    [ISO 8601](https://en.wikipedia.org/wiki/ISO_week_date).
    """
    FORTNIGHT: _CalendarPeriod.ValueType  # 3
    """A fortnight. The first calendar fortnight of the year begins at the start
    of week 1 according to
    [ISO 8601](https://en.wikipedia.org/wiki/ISO_week_date).
    """
    MONTH: _CalendarPeriod.ValueType  # 4
    """A month."""
    QUARTER: _CalendarPeriod.ValueType  # 5
    """A quarter. Quarters start on dates 1-Jan, 1-Apr, 1-Jul, and 1-Oct of each
    year.
    """
    HALF: _CalendarPeriod.ValueType  # 6
    """A half-year. Half-years start on dates 1-Jan and 1-Jul."""
    YEAR: _CalendarPeriod.ValueType  # 7
    """A year."""

class CalendarPeriod(_CalendarPeriod, metaclass=_CalendarPeriodEnumTypeWrapper):
    """A `CalendarPeriod` represents the abstract concept of a time period that has
    a canonical start. Grammatically, "the start of the current
    `CalendarPeriod`." All calendar times begin at midnight UTC.
    """

CALENDAR_PERIOD_UNSPECIFIED: CalendarPeriod.ValueType  # 0
"""Undefined period, raises an error."""
DAY: CalendarPeriod.ValueType  # 1
"""A day."""
WEEK: CalendarPeriod.ValueType  # 2
"""A week. Weeks begin on Monday, following
[ISO 8601](https://en.wikipedia.org/wiki/ISO_week_date).
"""
FORTNIGHT: CalendarPeriod.ValueType  # 3
"""A fortnight. The first calendar fortnight of the year begins at the start
of week 1 according to
[ISO 8601](https://en.wikipedia.org/wiki/ISO_week_date).
"""
MONTH: CalendarPeriod.ValueType  # 4
"""A month."""
QUARTER: CalendarPeriod.ValueType  # 5
"""A quarter. Quarters start on dates 1-Jan, 1-Apr, 1-Jul, and 1-Oct of each
year.
"""
HALF: CalendarPeriod.ValueType  # 6
"""A half-year. Half-years start on dates 1-Jan and 1-Jul."""
YEAR: CalendarPeriod.ValueType  # 7
"""A year."""
global___CalendarPeriod = CalendarPeriod
